<?php
require_once("hooks.php");

new ossms();

class ossms 
{
    
    private $optOutActive;
    private $id_product;
    
    public function __construct() 
    {           
        $check_query = tep_db_query("SELECT configuration_value FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'MODULE_SMS_STATUS'");
        if(tep_db_num_rows($check_query))
        {
            $result = tep_db_query("SELECT * FROM ".DB_PREFIX."products where products_model like 'osOrderSMS' limit 1");

            if (tep_db_num_rows($result))
            {
                $row = tep_db_fetch_array($result);
                $this->id_product = $row["products_id"];
            }

            $result = tep_db_query("SELECT active FROM ".DB_PREFIX."sp_optout_prices limit 1");

            if (tep_db_num_rows($result))
            {
                $row = tep_db_fetch_array($result);
                $this->optOutActive =  $row["active"];
            }
            
            $auto = $this->isAutoOptOut();
            
            if($auto == false && $this->optOutActive && !isset($_SESSION["SMS_IN_CART"]))
            {
                $_SESSION["SMS_IN_CART"] = false;
            } 
            
            $this->hook();
        }
    }
  
    private function hook()
    {       
        if(self::checkAction("update_order"))
        {
            $hooks = new ModelSmsHooks();
            $hooks->changeOrderStatusHook($_POST["status"], "", $_GET["oID"]);
        } 
        elseif(self::isFile("contact_us.php") && $_GET["action"] == "send")
        {
            self::savePost();
        }        
        elseif(self::checkSendForm("contact_us.php") && $_GET["action"] == "success")
        {
            $postSaved = self::restorePost();

            $hooks = new ModelSmsHooks();
            $hooks->contactFormHook(0, $postSaved["enquiry"], $postSaved["email"], $postSaved["name"]);
        }
        elseif(self::isFile("categories.php") && self::checkAction("delete_product_confirm") && isset($_POST["products_id"]))
        {           
            $hooks = new ModelSmsHooks();
            $hooks->productDeleteHook($_POST["products_id"]);
        }
        elseif(self::checkSendForm("create_account.php", "process")) 
        {
            self::savePost();
        } 
        elseif(self::checkSendForm("create_account_success.php"))
        {            
            $hooks = new ModelSmsHooks();
            $hooks->customerAddHook(0, $_SESSION["customer_id"]);
            self::restorePost();
        }
        elseif(self::checkSendForm("checkout_confirmation.php", true))
        {
            self::saveValue("order", true);
            self::saveValue("cart", $_SESSION["cart"]->contents);
        }
        elseif(self::checkSendForm("checkout_success.php", false, "order"))
        {
            $cart = self::restoreValue("cart");

            if(array_key_exists($this->id_product, $cart))
            {
                tep_db_query("UPDATE products SET products_quantity = 1000 WHERE products_id = ".mysql_escape_string($this->id_product));
            }
            
            $optOut = (($this->optOutActive)?($_SESSION["SMS_IN_CART"]):(true));

            $result = tep_db_query("SELECT orders_id FROM ".DB_PREFIX."orders WHERE customers_id = ".$_SESSION["customer_id"]." ORDER BY orders_id DESC LIMIT 1");
            
            if (tep_db_num_rows($result))
            {
                while ($row = tep_db_fetch_array($result))
                {
                    $order_id = $row['orders_id'];
                }
            }

            $hooks = new ModelSmsHooks();
            $hooks->orderAddHook($_SESSION["customer_id"], $order_id, $_SESSION['comments'], $optOut);

            unset($_SESSION["SMS_IN_CART"]);

            $this->outOfStock($cart);
            self::restoreValue("order");
        }
        elseif(self::checkSendForm("product_info.php", "add_product"))
        {
            self::saveValue("cart_add", true);
        }
        elseif(self::checkSendForm("shopping_cart.php", "remove_product"))
        {
            self::saveValue("cart_remove", true);
        }
        elseif(self::checkSendForm("shopping_cart.php", false, "cart_add"))
        {
            if($this->optOutActive)
            {
                $this->optOutAdd();
            }
            self::restoreValue("cart_add");
        }
        elseif(self::checkSendForm("shopping_cart.php", false, "cart_remove"))
        {            
            if($this->optOutActive)
            {
                $this->optOutRemove();   
            }
            self::restoreValue("cart_remove");
        }
    }
    
    private static function checkSendForm($filename, $type = false, $sub = "hookPost")
    {
        $filename = "/".$filename;
        
        if($filename == strrchr($_SERVER["SCRIPT_NAME"],"/") && $type === true)
        {
            return true;
        }
        elseif($filename == strrchr($_SERVER["SCRIPT_NAME"],"/") && $type === false && $_SESSION["ossms"][$sub] != NULL)
        {
                return true;
        }
        elseif(isset($_REQUEST["action"]) && $filename == strrchr($_SERVER["SCRIPT_NAME"],"/") && $_REQUEST != NULL && $_REQUEST["action"] == $type)
        {
                return true;
        }
        elseif($_POST == NULL)
        {
            return false;
        }
        else
        {
            return false; 
        }
    }
    
    private static function checkAction($action, $type = "action")
    {
        if($action == NULL)
        {
            return false;
        }
        elseif(isset($_GET[$type]) && $action == $_GET[$type] && $_POST != NULL)
        {
            return true;
        }
        else
        {
            return false;
        }
    } 
    
    private static function savePost()
    {
        $_SESSION["ossms"]["hookPost"] = $_POST;
    }
    
    private static function restorePost()
    {
        $post = $_SESSION["ossms"]["hookPost"];
        unset($_SESSION["ossms"]["hookPost"]);
        return $post;
    }
    
    private static function saveValue($flagName, $flagValue)
    {
        if($flagName == "hookPost")
        {
            return false;
        }
        
        if(isset($flagName) && isset($flagValue))
        {
            $_SESSION["ossms"][$flagName] = $flagValue;
        }
        return false;
    }
    
    private static function restoreValue($flagName)
    {
        $value = $_SESSION["ossms"][$flagName];
        unset($_SESSION["ossms"][$flagName]);
        return $value;
    }
    
    private function isAutoOptOut()
    {
        $id_shop = 0;

        $result = tep_db_query("SELECT * FROM `" . DB_PREFIX . "sp_config` WHERE `shop_id` = '".$id_shop."' AND `config_name` = 'optout_auto'");

        if (tep_db_num_rows($result))
        {
            while ($row = tep_db_fetch_array($result))
            {
                return $row["config_value"];
            }
        }
        return true;
    }
    
    private function optOutAdd()
    {        
        $auto = $this->isAutoOptOut();
                
        if($_SESSION['cart']->in_cart($this->id_product))
        {
            if(!$auto)
            {
                $_SESSION["SMS_IN_CART"] = true;
            }
        }
        
        if($this->id_product != NULL)
        {
            if(count($_SESSION["cart"]->contents)>0 && !$_SESSION['cart']->in_cart($this->id_product) && $_SESSION["SMS_IN_CART"] !== false)
            {
                if($auto)
                {
                    $_SESSION["cart"]->add_cart($this->id_product);
                    $_SESSION["SMS_IN_CART"] = true;
                }
            }
        }
        
        if(count($_SESSION["cart"]->contents)==1 && $_SESSION['cart']->in_cart($this->id_product))
        {
            if($auto)
            {
                $_SESSION["cart"]->remove($this->id_product); 
                unset($_SESSION["SMS_IN_CART"]);
            }
        }
    }
    
    private function optOutRemove()
    {
        if($this->id_product != NULL)
        {
            if(count($_SESSION["cart"]->contents)==1 && $_SESSION['cart']->in_cart($this->id_product))
            {
               $_SESSION["cart"]->remove($this->id_product); 
               unset($_SESSION["SMS_IN_CART"]);
            }

            if($_SESSION["SMS_IN_CART"] && !$_SESSION['cart']->in_cart($this->id_product))
            {
                $_SESSION["SMS_IN_CART"] = false;
            }

            if(!count($_SESSION["cart"]->contents))
            {
               unset($_SESSION["SMS_IN_CART"]); 
            }
        }
    }
    
    private static function isFile($filename)
    {
        $filename = "/".$filename;
        
        if($filename == strrchr($_SERVER["SCRIPT_NAME"],"/"))
        {
            return true;
        }
        return false;
    }
    
    static public function isEmail($email) 
    {
        return preg_match('|^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]{2,})+$|i', $email);
    }
        
    private function outOfStock($cart)
    {
        $products = array();
        foreach($cart as $key => $value)
        {
            if(strpos($key, "{"))
            {
                $products[] = substr($key, 0, strpos($key, "{"));
            } else {
                $products[] = $key;
            }
        }
        $hooks = new ModelSmsHooks();
        
        $products = implode(", ", $products);

        if(!empty($cart))
        { 
            $result = tep_db_query("SELECT * FROM ".DB_PREFIX."products WHERE products_id IN ($products) AND products_quantity = 0;");
            if(tep_db_num_rows($result))
            {
                while ($row = tep_db_fetch_array($result))
                {
                    $hooks->productOutOfStockHook($row["products_id"], 1, $row["products_model"], $_SESSION["customer_id"], 0);
                }
            }
        }
    }
}

    function getTimezones()
    {
        $result = tep_db_query("SELECT * FROM ".DB_PREFIX."configuration where configuration_key='MODULE_SMS_TIMEZONE'");

        if ($result != NULL)
        {
            $row = tep_db_fetch_array($result);
            $timezoneActual = $row["configuration_value"];   
        }
    
        $key = "MODULE_SMS_TIMEZONE";
        $name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
        $timezone = array();
        $result = tep_db_query("SELECT * FROM ".DB_PREFIX."configuration where configuration_key='STORE_COUNTRY'");

        if ($result != NULL)
        {
            $row = tep_db_fetch_array($result);
            $country = $row["configuration_value"];          

            $result = tep_db_query("SELECT * FROM ".DB_PREFIX."countries where countries_id = '".mysql_escape_string($country)."'");

            if ($result != NULL)
            {
                $row = tep_db_fetch_array($result) ;  
                $isoCode = $row["countries_iso_code_2"];  

                $timezoneArray = DateTimeZone::listIdentifiers(4096, $isoCode);
                $timezone = $timezoneArray;

                if(empty($timezone))
                {
                    $timezone[]='Europe/Prague';
                }
            } 
            else 
            {
                $timezone[]='Europe/Prague';	
            }
        } 
        else 
        {
            $timezone[]='Europe/Prague';	
        }
        
        if(!in_array($timezoneActual, $timezone)){
            $timezone[] = $timezoneActual;
        }
        
        $selected = "";
        $output  = "<select name=\"".$name."\">";
        foreach ($timezone as $item)
        {
            if($timezoneActual == $item) $selected = " selected"; else $selected = "";
            $output .= "<option value=\"".$item."\" ".$selected.">".$item."</option>";
        }
        $output .= "</select>";
        return $output;
    }

    function getLanguagesSms()
    {
        $lang_iso = array('aa' => 'Afar',  'ab' => 'Abkhaz',  'ae' => 'Avestan',  'af' => 'Afrikaans',  'ak' => 'Akan',  'am' => 'Amharic',  'an' => 'Aragonese',  'ar' => 'Arabic',  'as' => 'Assamese',  'av' => 'Avaric',  'ay' => 'Aymara',  'az' => 'Azerbaijani',  'ba' => 'Bashkir',  'be' => 'Belarusian',  'bg' => 'Bulgarian',  'bh' => 'Bihari',  'bi' => 'Bislama',  'bm' => 'Bambara',  'bn' => 'Bengali',  'bo' => 'Tibetan Standard, Tibetan, Central',  'br' => 'Breton',  'bs' => 'Bosnian',  'ca' => 'Catalan; Valencian',  'ce' => 'Chechen',  'ch' => 'Chamorro',  'co' => 'Corsican',  'cr' => 'Cree',  'cs' => 'Czech',  'cu' => 'Old Church Slavonic, Church Slavic, Church Slavonic, Old Bulgarian, Old Slavonic',  'cv' => 'Chuvash',  'cy' => 'Welsh',  'da' => 'Danish',  'de' => 'German',  'dv' => 'Divehi; Dhivehi; Maldivian;',  'dz' => 'Dzongkha',  'ee' => 'Ewe',  'el' => 'Greek, Modern',  'en' => 'English',  'eo' => 'Esperanto',  'es' => 'Spanish; Castilian',  'et' => 'Estonian',  'eu' => 'Basque',  'fa' => 'Persian',  'ff' => 'Fula; Fulah; Pulaar; Pular',  'fi' => 'Finnish',  'fj' => 'Fijian',  'fo' => 'Faroese',  'fr' => 'French',  'fy' => 'Western Frisian',  'ga' => 'Irish',  'gd' => 'Scottish Gaelic; Gaelic',  'gl' => 'Galician',  'gn' => 'GuaranÃ­',  'gu' => 'Gujarati',  'gv' => 'Manx',  'ha' => 'Hausa',  'he' => 'Hebrew (modern)',  'hi' => 'Hindi',  'ho' => 'Hiri Motu',  'hr' => 'Croatian',  'ht' => 'Haitian; Haitian Creole',  'hu' => 'Hungarian',  'hy' => 'Armenian',  'hz' => 'Herero',  'ia' => 'Interlingua',  'id' => 'Indonesian',  'ie' => 'Interlingue',  'ig' => 'Igbo',  'ii' => 'Nuosu',  'ik' => 'Inupiaq',  'io' => 'Ido',  'is' => 'Icelandic',  'it' => 'Italian',  'iu' => 'Inuktitut',  'ja' => 'Japanese (ja)',  'jv' => 'Javanese (jv)',  'ka' => 'Georgian',  'kg' => 'Kongo',  'ki' => 'Kikuyu, Gikuyu',  'kj' => 'Kwanyama, Kuanyama',  'kk' => 'Kazakh',  'kl' => 'Kalaallisut, Greenlandic',  'km' => 'Khmer',  'kn' => 'Kannada',  'ko' => 'Korean',  'kr' => 'Kanuri',  'ks' => 'Kashmiri',  'ku' => 'Kurdish',  'kv' => 'Komi',  'kw' => 'Cornish',  'ky' => 'Kirghiz, Kyrgyz',  'la' => 'Latin',  'lb' => 'Luxembourgish, Letzeburgesch',  'lg' => 'Luganda',  'li' => 'Limburgish, Limburgan, Limburger',  'ln' => 'Lingala',  'lo' => 'Lao',  'lt' => 'Lithuanian',  'lu' => 'Luba-Katanga',  'lv' => 'Latvian',  'mg' => 'Malagasy',  'mh' => 'Marshallese',  'mi' => 'Maori',  'mk' => 'Macedonian',  'ml' => 'Malayalam',  'mn' => 'Mongolian',  'mr' => 'Marathi (Mara?hi)',  'ms' => 'Malay',  'mt' => 'Maltese',  'my' => 'Burmese',  'na' => 'Nauru',  'nb' => 'Norwegian BokmÃ¥l',  'nd' => 'North Ndebele',  'ne' => 'Nepali',  'ng' => 'Ndonga',  'nl' => 'Dutch',  'nn' => 'Norwegian Nynorsk',  'no' => 'Norwegian',  'nr' => 'South Ndebele',  'nv' => 'Navajo, Navaho',  'ny' => 'Chichewa; Chewa; Nyanja',  'oc' => 'Occitan',  'oj' => 'Ojibwe, Ojibwa',  'om' => 'Oromo',  'or' => 'Oriya',  'os' => 'Ossetian, Ossetic',  'pa' => 'Panjabi, Punjabi',  'pi' => 'Pali',  'pl' => 'Polish',  'ps' => 'Pashto, Pushto',  'pt' => 'Portuguese',  'qu' => 'Quechua',  'rm' => 'Romansh',  'rn' => 'Kirundi',  'ro' => 'Romanian, Moldavian, Moldovan',  'ru' => 'Russian',  'rw' => 'Kinyarwanda',  'sa' => 'Sanskrit (Sa?sk?ta)',  'sc' => 'Sardinian',  'sd' => 'Sindhi',  'se' => 'Northern Sami',  'sg' => 'Sango',  'si' => 'Sinhala, Sinhalese',  'sk' => 'Slovak',  'sl' => 'Slovene',  'sm' => 'Samoan',  'sn' => 'Shona',  'so' => 'Somali',  'sq' => 'Albanian',  'sr' => 'Serbian',  'ss' => 'Swati',  'st' => 'Southern Sotho',  'su' => 'Sundanese',  'sv' => 'Swedish',  'sw' => 'Swahili',  'ta' => 'Tamil',  'te' => 'Telugu',  'tg' => 'Tajik',  'th' => 'Thai',  'ti' => 'Tigrinya',  'tk' => 'Turkmen',  'tl' => 'Tagalog',  'tn' => 'Tswana',  'to' => 'Tonga (Tonga Islands)',  'tr' => 'Turkish',  'ts' => 'Tsonga',  'tt' => 'Tatar',  'tw' => 'Twi',  'ty' => 'Tahitian',  'ug' => 'Uighur, Uyghur',  'uk' => 'Ukrainian',  'ur' => 'Urdu',  'uz' => 'Uzbek',  've' => 'Venda',  'vi' => 'Vietnamese',  'vo' => 'VolapÃ¼k',  'wa' => 'Walloon',  'wo' => 'Wolof',  'xh' => 'Xhosa',  'yi' => 'Yiddish',  'yo' => 'Yoruba',  'za' => 'Zhuang, Chuang',  'zh' => 'Chinese',  'zu' => 'Zulu',  );

        $result = tep_db_query("SELECT * FROM ".DB_PREFIX."configuration where configuration_key='MODULE_SMS_LANG'");

        if ($result != NULL)
        {
            $row = tep_db_fetch_array($result);
            $langActual = $row["configuration_value"];   
        }
    
        $key = "MODULE_SMS_LANG";
        $name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
        
        $configList = array();
        $d = dir(DIR_FS_CATALOG."ossms/lang/");
        while (false !== ($entry = $d->read()))
        {
            if(is_dir(DIR_FS_CATALOG."ossms/lang/".$entry) && $entry != ".." && $entry != ".")
            {
                $configList[$entry] = $lang_iso[$entry];
            }
        }
        $d->close();
        $selected = "";
        $output  = "<select name=\"".$name."\">";
        foreach ($configList as $key => $item)
        {
            if($langActual == $key) $selected = " selected"; else $selected = "";
            $output .= "<option value=\"".$key."\" ".$selected.">".$item."</option>";
        }
        $output .= "</select>";
        return $output;
    }
?>
